---------------------------------------------------------------------
-- Microsoft SQL Server 2012: Основы T-SQL
-- Глава 03 - Соединения
-- Решения
-- © Ицик Бен-Ган
---------------------------------------------------------------------

-- 1 
-- 1-1 
-- Напишите запрос, который генерирует по пять копий каждой строки из таблицы HR.Employees
-- Используемые таблицы: Employees и Nums

-- Ожидаемый результат
empid       firstname  lastname        n
----------- ---------- --------------- -----------
1           Сара       Дэвис           1
2           Дон        Функ            1
3           Джуди      Лью             1
4           Иаиль      Пелед           1
5           Свен       Бак             1
6           Пол        Суурс           1
7           Рассел     Кинг            1
8           Мария      Камерон         1
9           Зоя        Долгопятова     1
1           Сара       Дэвис           2
2           Дон        Функ            2
3           Джуди      Лью             2
4           Иаиль      Пелед           2
5           Свен       Бак             2
6           Пол        Суурс           2
7           Рассел     Кинг            2
8           Мария      Камерон         2
9           Зоя        Долгопятова     2
1           Сара       Дэвис           3
2           Дон        Функ            3
3           Джуди      Лью             3
4           Иаиль      Пелед           3
5           Свен       Бак             3
6           Пол        Суурс           3
7           Рассел     Кинг            3
8           Мария      Камерон         3
9           Зоя        Долгопятова     3
1           Сара       Дэвис           4
2           Дон        Функ            4
3           Джуди      Лью             4
4           Иаиль      Пелед           4
5           Свен       Бак             4
6           Пол        Суурс           4
7           Рассел     Кинг            4
8           Мария      Камерон         4
9           Зоя        Долгопятова     4
1           Сара       Дэвис           5
2           Дон        Функ            5
3           Джуди      Лью             5
4           Иаиль      Пелед           5
5           Свен       Бак             5
6           Пол        Суурс           5
7           Рассел     Кинг            5
8           Мария      Камерон         5
9           Зоя        Долгопятова     5

(45 row(s) affected)

-- Решение
SELECT E.empid, E.firstname, E.lastname, N.n
FROM HR.Employees AS E
  CROSS JOIN dbo.Nums AS N 
WHERE N.n <= 5
ORDER BY n, empid;

-- 1-2  (углубленное, по желанию)
-- Напишите запрос, который возвращает по одной строке для каждого
-- сотрудника и дня в диапазоне с 12 июня 2009 по 16 июня 2009.
-- Используемые таблицы: Employees и Nums

-- Ожидаемый результат
empid       dt
----------- -----------------------
1           2009-06-12 00:00:00.000
1           2009-06-13 00:00:00.000
1           2009-06-14 00:00:00.000
1           2009-06-15 00:00:00.000
1           2009-06-16 00:00:00.000
2           2009-06-12 00:00:00.000
2           2009-06-13 00:00:00.000
2           2009-06-14 00:00:00.000
2           2009-06-15 00:00:00.000
2           2009-06-16 00:00:00.000
3           2009-06-12 00:00:00.000
3           2009-06-13 00:00:00.000
3           2009-06-14 00:00:00.000
3           2009-06-15 00:00:00.000
3           2009-06-16 00:00:00.000
4           2009-06-12 00:00:00.000
4           2009-06-13 00:00:00.000
4           2009-06-14 00:00:00.000
4           2009-06-15 00:00:00.000
4           2009-06-16 00:00:00.000
5           2009-06-12 00:00:00.000
5           2009-06-13 00:00:00.000
5           2009-06-14 00:00:00.000
5           2009-06-15 00:00:00.000
5           2009-06-16 00:00:00.000
6           2009-06-12 00:00:00.000
6           2009-06-13 00:00:00.000
6           2009-06-14 00:00:00.000
6           2009-06-15 00:00:00.000
6           2009-06-16 00:00:00.000
7           2009-06-12 00:00:00.000
7           2009-06-13 00:00:00.000
7           2009-06-14 00:00:00.000
7           2009-06-15 00:00:00.000
7           2009-06-16 00:00:00.000
8           2009-06-12 00:00:00.000
8           2009-06-13 00:00:00.000
8           2009-06-14 00:00:00.000
8           2009-06-15 00:00:00.000
8           2009-06-16 00:00:00.000
9           2009-06-12 00:00:00.000
9           2009-06-13 00:00:00.000
9           2009-06-14 00:00:00.000
9           2009-06-15 00:00:00.000
9           2009-06-16 00:00:00.000

(45 row(s) affected)

-- Решение
SELECT E.empid,
  DATEADD(day, D.n - 1, '20090612') AS dt
FROM HR.Employees AS E
  CROSS JOIN Nums AS D
WHERE D.n <= DATEDIFF(day, '20090612', '20090616') + 1
ORDER BY empid, dt;

-- 2
-- Запрос должен отобрать всех клиентов из США и вернуть для каждого
-- из них количество сделанных заказов и общее число заказанных товаров. 
-- Используемые таблицы: Customers, Orders и OrderDetails

-- Ожидаемый результат
custid      numorders   totalqty
----------- ----------- -----------
32          11          345
36          5           122
43          2           20
45          4           181
48          8           134
55          10          603
65          18          1383
71          31          4958
75          9           327
77          4           46
78          3           59
82          3           89
89          14          1063

(13 row(s) affected)

-- Решение
SELECT C.custid, COUNT(DISTINCT O.orderid) AS numorders, SUM(OD.qty) AS totalqty
FROM Sales.Customers AS C
  JOIN Sales.Orders AS O
    ON O.custid = C.custid
  JOIN Sales.OrderDetails AS OD
    ON OD.orderid = O.orderid
WHERE C.country = N'США'
GROUP BY C.custid;

-- 3
-- Нужно получить список клиентов с их заказами. В результат
-- должны попасть даже те клиенты, которые ничего не заказывали.
-- Используемые таблицы: Customers и Orders 

--  Ожидаемый результат
custid      companyname           orderid     orderdate
----------- --------------------- ----------- -----------------------
85          Клиент ENQZT          10248       2006-07-04 00:00:00.000
79          Клиент FAPSM          10249       2006-07-05 00:00:00.000
34          Клиент IBVRG          10250       2006-07-08 00:00:00.000
84          Клиент NRCSK          10251       2006-07-08 00:00:00.000
...
73          Клиент JMIKW          11074       2008-05-06 00:00:00.000
68          Клиент CCKOT          11075       2008-05-06 00:00:00.000
9           Клиент RTXGC          11076       2008-05-06 00:00:00.000
65          Клиент NYUHS          11077       2008-05-06 00:00:00.000
22          Клиент DTDMN          NULL        NULL
57          Клиент WVAXS          NULL        NULL

(832 row(s) affected)

-- Решение
SELECT C.custid, C.companyname, O.orderid, O.orderdate
FROM Sales.Customers AS C
  LEFT OUTER JOIN Sales.Orders AS O
    ON O.custid = C.custid;

-- 4
-- Верните список клиентов, которые не размещали заказов
-- Используемые таблицы: Customers и Orders

--  Ожидаемый результат
custid      companyname
----------- ---------------
22          Клиент DTDMN
57          Клиент WVAXS

(2 row(s) affected)

-- Решение
SELECT C.custid, C.companyname
FROM Sales.Customers AS C
  LEFT OUTER JOIN Sales.Orders AS O
    ON O.custid = C.custid
WHERE O.orderid IS NULL;

-- 5
-- Получите список заказов и клиентов, которые размещали заказы 12 февраля 2007 года. 
-- Используемые таблицы: Customers и Orders 

--  Ожидаемый результат
custid      companyname   orderid     orderdate
----------- ------------- ----------- -----------------------
66          Клиент LHANT  10443       2007-02-12 00:00:00.000
5           Клиент HGVLZ  10444       2007-02-12 00:00:00.000

(2 row(s) affected)

-- Решение
SELECT C.custid, C.companyname, O.orderid, O.orderdate
FROM Sales.Customers AS C
  JOIN Sales.Orders AS O
    ON O.custid = C.custid
WHERE O.orderdate = '20070212';

-- 6 (углубленное, по желанию)
-- Получите список клиентов, которые размещали заказы 12 февраля 2007 года.
-- В результат должны войти столбцы из таблицы Sales.Orders и клиенты,
-- у которых не было заказов в этот день. 
-- Используемые таблицы: Customers и Orders

--  Ожидаемый результат
custid      companyname   orderid     orderdate
----------- ------------  ----------- -----------------------
72          Клиент AHPOP  NULL        NULL
58          Клиент AHXHT  NULL        NULL
25          Клиент AZJED  NULL        NULL
18          Клиент BSVAR  NULL        NULL
91          Клиент CCFIZ  NULL        NULL
...
33          Клиент FVXPQ  NULL        NULL
53          Клиент GCJSG  NULL        NULL
39          Клиент GLLAG  NULL        NULL
16          Клиент GYBBY  NULL        NULL
4           Клиент HFBZG  NULL        NULL
5           Клиент HGVLZ  10444       2007-02-12 00:00:00.000
42          Клиент IAIJK  NULL        NULL
34          Клиент IBVRG  NULL        NULL
63          Клиент IRRVL  NULL        NULL
73          Клиент JMIKW  NULL        NULL
15          Клиент JUWXK  NULL        NULL
...
21          Клиент KIDPX  NULL        NULL
30          Клиент KSLQF  NULL        NULL
55          Клиент KZQZT  NULL        NULL
71          Клиент LCOUJ  NULL        NULL
77          Клиент LCYBZ  NULL        NULL
66          Клиент LHANT  10443       2007-02-12 00:00:00.000
38          Клиент LJUCA  NULL        NULL
59          Клиент LOLJO  NULL        NULL
36          Клиент LVJSO  NULL        NULL
64          Клиент LWGMD  NULL        NULL
29          Клиент MDLWA  NULL        NULL
...

(91 row(s) affected)

-- Решение
SELECT C.custid, C.companyname, O.orderid, O.orderdate
FROM Sales.Customers AS C
  LEFT OUTER JOIN Sales.Orders AS O
    ON O.custid = C.custid
    AND O.orderdate = '20070212';

-- 7 (углубленное, по желанию)
-- Получите список всех клиентов. Результат должен содержать
-- столбец со значениями «Да/Нет», которые определяются тем,
-- размещал ли клиент заказ 12 февраля 2007 года.
-- Используемые таблицы: Customers и Orders 

--  Ожидаемый результат
custid      companyname               HasOrderOn20070212
----------- ------------------------- ------------------
1           Клиент NRZBB              Нет
2           Клиент MLTDN              Нет
3           Клиент KBUDE              Нет
4           Клиент HFBZG              Нет
5           Клиент HGVLZ              Да
6           Клиент XHXJV              Нет
7           Клиент QXVLA              Нет
8           Клиент QUHWH              Нет
9           Клиент RTXGC              Нет
10          Клиент EEALV              Нет
...

(91 row(s) affected)

-- Решение
SELECT DISTINCT C.custid, C.companyname,
  CASE WHEN O.orderid IS NOT NULL THEN 'Да' ELSE 'Нет' END AS [HasOrderOn20070212]
FROM Sales.Customers AS C
  LEFT OUTER JOIN Sales.Orders AS O
    ON O.custid = C.custid
    AND O.orderdate = '20070212';
