---------------------------------------------------------------------
-- Microsoft SQL Server 2012: Основы T-SQL
-- Глава 04 - Вложенные запросы
-- Решения
-- © Ицик Бен-Ган
---------------------------------------------------------------------

-- 1 
-- Напишите запрос, который возвращает все заказы, сделанные
-- в последний день, учтенный в таблице Orders.
-- Используемые таблицы: Orders

-- Ожидаемый результат
orderid     orderdate               custid      empid
----------- ----------------------- ----------- -----------
11077       2008-05-06 00:00:00.000 65          1
11076       2008-05-06 00:00:00.000 9           4
11075       2008-05-06 00:00:00.000 68          8
11074       2008-05-06 00:00:00.000 73          7

(4 row(s) affected)

-- Решение
USE TSQL2012;

SELECT orderid, orderdate, custid, empid
FROM Sales.Orders
WHERE orderdate =
  (SELECT MAX(O.orderdate) FROM Sales.Orders AS O);

-- 2 (углубленное, по желанию)
-- Напишите запрос, который возвращает все заказы, размещенные клиентом
-- (или клиентами) с самым большим количеством заказов. Учитывайте возможность
-- того, что одно и то же количество заказов может быть у нескольких клиентов.
-- Используемые таблицы: Orders

-- Ожидаемый результат:
custid      orderid     orderdate               empid
----------- ----------- ----------------------- -----------
71          10324       2006-10-08 00:00:00.000 9
71          10393       2006-12-25 00:00:00.000 1
71          10398       2006-12-30 00:00:00.000 2
71          10440       2007-02-10 00:00:00.000 4
71          10452       2007-02-20 00:00:00.000 8
71          10510       2007-04-18 00:00:00.000 6
71          10555       2007-06-02 00:00:00.000 6
71          10603       2007-07-18 00:00:00.000 8
71          10607       2007-07-22 00:00:00.000 5
71          10612       2007-07-28 00:00:00.000 1
71          10627       2007-08-11 00:00:00.000 8
71          10657       2007-09-04 00:00:00.000 2
71          10678       2007-09-23 00:00:00.000 7
71          10700       2007-10-10 00:00:00.000 3
71          10711       2007-10-21 00:00:00.000 5
71          10713       2007-10-22 00:00:00.000 1
71          10714       2007-10-22 00:00:00.000 5
71          10722       2007-10-29 00:00:00.000 8
71          10748       2007-11-20 00:00:00.000 3
71          10757       2007-11-27 00:00:00.000 6
71          10815       2008-01-05 00:00:00.000 2
71          10847       2008-01-22 00:00:00.000 4
71          10882       2008-02-11 00:00:00.000 4
71          10894       2008-02-18 00:00:00.000 1
71          10941       2008-03-11 00:00:00.000 7
71          10983       2008-03-27 00:00:00.000 2
71          10984       2008-03-30 00:00:00.000 1
71          11002       2008-04-06 00:00:00.000 4
71          11030       2008-04-17 00:00:00.000 7
71          11031       2008-04-17 00:00:00.000 6
71          11064       2008-05-01 00:00:00.000 1

(31 row(s) affected)

-- Решение
SELECT custid, orderid, orderdate, empid
FROM Sales.Orders
WHERE custid IN
  (SELECT TOP (1) WITH TIES O.custid
   FROM Sales.Orders AS O
   GROUP BY O.custid
   ORDER BY COUNT(*) DESC);

-- 3
-- Напишите запрос, который возвращает список сотрудников,
-- не обрабатывавших заказы 1 мая 2008 года.
-- Используемые таблицы: Employees и Orders

-- Ожидаемый результат:
empid       FirstName  lastname
----------- ---------- ---------------
3           Джуди      Лью
5           Свен       Бак
6           Пол        Суурс
9           Зоя        Долгопятова

(4 row(s) affected)

-- Решение
SELECT empid, FirstName, lastname
FROM HR.Employees
WHERE empid NOT IN
  (SELECT O.empid
   FROM Sales.Orders AS O
   WHERE O.orderdate >= '20080501');

-- 4
-- Получите список стран, в которых есть клиенты, но нет сотрудников
-- Используемые таблицы: Customers и Employees 

-- Ожидаемый результат:
country
---------------
Австрия
Аргентина
Бельгия
Бразилия
Венесуэла
Германия
Дания
Ирландия
Испания
Италия
Канада
Мексика
Норвегия
Польша
Португалия
Финляндия
Франция
Швейцария
Швеция

(19 row(s) affected)

-- Решение
SELECT DISTINCT country
FROM Sales.Customers
WHERE country NOT IN
  (SELECT E.country FROM HR.Employees AS E);

-- 5
-- Напишите запрос, который возвращает все заказы,
-- размещенные в последний день активности каждого клиента.
-- Используемые таблицы: Orders 

-- Ожидаемый результат:
custid      orderid     orderdate               empid
----------- ----------- ----------------------- -----------
1           11011       2008-04-09 00:00:00.000 3
2           10926       2008-03-04 00:00:00.000 4
3           10856       2008-01-28 00:00:00.000 3
4           11016       2008-04-10 00:00:00.000 9
5           10924       2008-03-04 00:00:00.000 3
...
87          11025       2008-04-15 00:00:00.000 6
88          10935       2008-03-09 00:00:00.000 4
89          11066       2008-05-01 00:00:00.000 7
90          11005       2008-04-07 00:00:00.000 2
91          11044       2008-04-23 00:00:00.000 4

(90 row(s) affected)

-- Решение
SELECT custid, orderid, orderdate, empid
FROM Sales.Orders AS O1
WHERE orderdate =
  (SELECT MAX(O2.orderdate)
   FROM Sales.Orders AS O2
   WHERE O2.custid = O1.custid)
ORDER BY custid;

-- 6
-- Напишите запрос, который возвращает список клиентов,
-- размещавших заказы в 2007, но не в 2008 году.
-- Используемые таблицы: Customers и Orders 

-- Ожидаемый результат:
custid      companyname
----------- ----------------
21          Клиент KIDPX
23          Клиент WVFAF
33          Клиент FVXPQ
36          Клиент LVJSO
43          Клиент UISOJ
51          Клиент PVDZC
85          Клиент ENQZT

(7 row(s) affected)

-- Решение
SELECT custid, companyname
FROM Sales.Customers AS C
WHERE EXISTS
  (SELECT *
   FROM Sales.Orders AS O
   WHERE O.custid = C.custid
     AND O.orderdate >= '20070101'
     AND O.orderdate < '20080101')
  AND NOT EXISTS
  (SELECT *
   FROM Sales.Orders AS O
   WHERE O.custid = C.custid
     AND O.orderdate >= '20080101'
     AND O.orderdate < '20090101');

-- 7 (углубленное, по желанию)
-- Напишите запрос, который возвращает список клиентов,
-- заказывавших товар под номером 12.
-- Используемые таблицы: Customers, Orders и OrderDetails 

-- Ожидаемый результат:
custid      companyname
----------- ---------------
48          Клиент DVFMB
39          Клиент GLLAG
71          Клиент LCOUJ
65          Клиент NYUHS
44          Клиент OXFRU
51          Клиент PVDZC
86          Клиент SNXOJ
20          Клиент THHDP
90          Клиент XBBVR
46          Клиент XPNIK
31          Клиент YJCBX
87          Клиент ZHYOS

(12 row(s) affected)

-- Решение
SELECT custid, companyname
FROM Sales.Customers AS C
WHERE EXISTS
  (SELECT *
   FROM Sales.Orders AS O
   WHERE O.custid = C.custid
     AND EXISTS
       (SELECT *
        FROM Sales.OrderDetails AS OD
        WHERE OD.orderid = O.orderid
          AND OD.ProductID = 12));

-- 8 (углубленное, по желанию)
-- Напишите запрос, который вычисляет общее текущее количество
-- заказанного товара для каждого клиента за каждый месяц.
-- Используемые таблицы: представление Sales.CustOrders 

-- Ожидаемый результат:
custid      ordermonth              qty         runqty
----------- ----------------------- ----------- -----------
1           2007-08-01 00:00:00.000 38          38
1           2007-10-01 00:00:00.000 41          79
1           2008-01-01 00:00:00.000 17          96
1           2008-03-01 00:00:00.000 18          114
1           2008-04-01 00:00:00.000 60          174
2           2006-09-01 00:00:00.000 6           6
2           2007-08-01 00:00:00.000 18          24
2           2007-11-01 00:00:00.000 10          34
2           2008-03-01 00:00:00.000 29          63
3           2006-11-01 00:00:00.000 24          24
3           2007-04-01 00:00:00.000 30          54
3           2007-05-01 00:00:00.000 80          134
3           2007-06-01 00:00:00.000 83          217
3           2007-09-01 00:00:00.000 102         319
3           2008-01-01 00:00:00.000 40          359
...

(636 row(s) affected)

-- Решение
SELECT custid, ordermonth, qty,
  (SELECT SUM(O2.qty)
   FROM Sales.CustOrders AS O2
   WHERE O2.custid = O1.custid
     AND O2.ordermonth <= O1.ordermonth) AS runqty
FROM Sales.CustOrders AS O1
ORDER BY custid, ordermonth;